#!/bin/bash
# projectid: 45451
# name: PATCH-X86-THIRD-0.1.0.sh

script_name=$(basename $0)
PWD=/etc/cpeagent/upgrade/${script_name%.*}

ret_success=0
ret_success_restart=1
ret_success_reboot=2
ret_fail_roolback=6
ret_fail_others=7



log_exit() 
{
    echo `date` "$script_name upgrade: ${1} exit $2" 
    exit ${2}
}


update_openssh()
{
    local_opensshversion=$(rpm -q --qf '%{version}\n'  openssh)
    upgrade_opensshversion="8.8p1"
    if [ $local_opensshversion = $upgrade_opensshversion ]; then
        echo "The local_opensshversion is $local_opensshversion equal to the version to be upgraded, no need to upgrade !"
        exit $ret_success
    else
        result_version=$(echo -e "$local_opensshversion\n$upgrade_opensshversion" | sort -V | head -n1)
        if [ $result_version = $local_opensshversion ]; then
            rpm -Uvh ${PWD}/openssh/openssh-8.8p1-2.el7.centos.x86_64.rpm ${PWD}/openssh/openssh-clients-8.8p1-2.el7.centos.x86_64.rpm ${PWD}/openssh/openssh-server-8.8p1-2.el7.centos.x86_64.rpm
            if [ $? -eq 0 ]; then
                echo  "upgrade openssh  success !"
                mod_sshd
                exit $ret_success_restart
            else
                echo "upgrade openssh failed !"
                exit $ret_fail_others
            fi
        elif [ $result_version = $upgrade_opensshversion ]; then
            echo "The local_opensshversion is $local_opensshversion greater than the version to be upgraded, no need to upgrade !"
            exit $ret_success
        fi
    fi
}


mod_sshd()
{
    chmod 600 /etc/ssh/ssh_host_*_key

    [ -e /etc/pam.d/sshd ] && {
        cat /etc/pam.d/sshd |grep "pam_motd.so$" > /dev/null
            if [ $? -eq 0 ]; then
                sed -i '/pam_motd.so/d' /etc/pam.d/sshd > /dev/null
            fi
        }

    [ -e /etc/ssh/sshd_config ] && {
        cat /etc/ssh/sshd_config |grep "^Port 20022" > /dev/null
            if [ $? -ne 0 ]; then
                cat /etc/ssh/sshd_config |grep "^Port "
                if [ $? -ne 0 ]; then
                    echo -e "\nPort 20022" >> /etc/ssh/sshd_config 2>/dev/null
                else
                    sed -i "s/Port.*$/Port 20022/g" /etc/ssh/sshd_config
                    sed -i "s/#Port.*$/Port 20022/g" /etc/ssh/sshd_config
                fi
            fi

            cat /etc/ssh/sshd_config |grep "^UseDNS no" > /dev/null
            if [ $? -ne 0 ]; then
                cat /etc/ssh/sshd_config |grep "^UseDNS "
                if [ $? -ne 0 ]; then
                    echo "UseDNS no" >> /etc/ssh/sshd_config 2>/dev/null
                else
                    sed -i "s/UseDNS.*$/UseDNS no/g" /etc/ssh/sshd_config
                    sed -i "s/#UseDNS.*$/UseDNS no/g" /etc/ssh/sshd_config
                fi
            fi

            cat /etc/ssh/sshd_config | grep "^PermitRootLogin yes" >/dev/null
            if [ $? -ne 0 ]; then
                cat /etc/ssh/sshd_config | grep "^PermitRootLogin"
                if [ $? -eq 0 ]; then
                    sed -i 's/PermitRootLogin.*$/PermitRootLogin yes/' /etc/ssh/sshd_config
                fi

                cat /etc/ssh/sshd_config | grep "^#PermitRootLogin" >/dev/null
                if [ $? -eq 0 ]; then
                    sed -i 's/#PermitRootLogin.*$/PermitRootLogin yes/' /etc/ssh/sshd_config
                fi
            fi

            cat /etc/ssh/sshd_config |grep "^PrintMotd yes" > /dev/null
            if [ $? -ne 0 ]; then
                cat /etc/ssh/sshd_config |grep "^PrintMotd "
                if [ $? -ne 0 ]; then
                    echo "PrintMotd yes" >> /etc/ssh/sshd_config 2>/dev/null
                else
                    sed -i "s/PrintMotd.*$/PrintMotd yes/g" /etc/ssh/sshd_config
                    sed -i "s/#PrintMotd.*$/PrintMotd yes/g" /etc/ssh/sshd_config
                fi
            fi
        }

    systemctl restart sshd
    if [ $? -eq 0 ]; then
        echo "upgrade openssh  success and restart sshd success !"
        return 0;
    else
        echo "restart sshd failed !"
        exit $ret_fail_others
    fi
}


install()
{
    update_openssh
}

uninstall()
{
    exit $ret_success
}

if [ "$1" == "install" ];then
    install
elif [ "$1" == "uninstall" ]; then
    uninstall
else
    log_exit "invalid args" $ret_fail_others
fi

